package testcase;

import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

/**
 * Classe cliente que verifica a existncia do bug introduzido no update25 do
 * Java7 conforme descrito em
 * http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=8019274.
 * 
 * A execuo do cliente, chamada por linha de comando, recebe como parmetro
 * "true" of "false". O valor "true" faz o teste usando a soluo de contorno. O
 * valor "false" executa o cliente sem a soluo de contorno e, portanto, mostra
 * a exceo de NullPointerException sendo lanada nas chamadas aos mtodos
 * SwingUtilities.invokeLater, SwingUtilities.isEventDispatchThread e
 * SwingUtilities.invokeAndWait.
 * 
 * 
 * @author Tecgraf PUC-Rio
 */
public class RmiClient {
  /**
   * Executa o teste.
   * 
   * @param args argumentos passados pela linha de comando. Aceita os valores
   *        "true" ou "false".
   * @throws Exception caso ocorra um erro durante a execuo do teste
   */
  public static void main(String[] args) throws Exception {
    System.out.println(">>Inicio do Teste");
    boolean useWorkAround = Boolean.parseBoolean(args[0]);
    Registry reg = LocateRegistry.getRegistry(RmiServiceImpl.PORT);
    RmiService serv = (RmiService) reg.lookup("demo");
    serv.testInvokeLater(useWorkAround);
    Thread.sleep(1000);
    serv.testIsEventDispatchThread(useWorkAround);
    Thread.sleep(1000);
    serv.testInvokeAndWait(useWorkAround);
    System.out.println(">>Fim do Teste");
  }
}