package testcase;

/**
 * Interface remota com os mtodos que testam as chamadas aos mtodos de
 * SwingUtilities que lanam a exceo NullPointerException quando chamados na
 * thread do RMI por aplicaes iniciadas com o Java WebStart.
 * 
 * @author Tecgraf PUC-Rio
 */
public interface RmiService extends java.rmi.Remote {
  /**
   * Mtodo chamado remotamente (na thread do RMI) que testa o uso do
   * SwingUtilities.invokeLater para alterar o valor do campo de texto da
   * janela.
   * 
   * @param useWorkAround {@code true} se o teste deve usar a soluo de
   *        contorno ou {@code false} caso contrrio
   * @throws java.rmi.RemoteException caso ocorra um erro RMI
   */
  void testInvokeLater(boolean useWorkAround) throws java.rmi.RemoteException;

  /**
   * Mtodo chamado remotamente (na thread do RMI) que testa o uso do
   * SwingUtilities.isEventDispatchThread para verificar se a thread corrente 
   * a EDT. Caso esteja na prpria EDT a alterao do campo de texto na janela
   * pode ser chamada diretamente pelo Swing. Seno, utiliza o
   * SwingUtilities.invokeLater para fazer a alterao no campo.
   * 
   * @param useWorkAround {@code true} se o teste deve usar a soluo de
   *        contorno ou {@code false} caso contrrio
   * @throws java.rmi.RemoteException caso ocorra um erro RMI
   */
  void testIsEventDispatchThread(boolean useWorkAround)
    throws java.rmi.RemoteException;

  /**
   * 
   * Mtodo chamado remotamente (na thread do RMI) que testa o uso do
   * SwingUtilities.invokeAndWait para alterar o valor do campo de texto da
   * janela.
   * 
   * @param useWorkAround {@code true} se o teste deve usar a soluo de
   *        contorno ou {@code false} caso contrrio
   * @throws java.rmi.RemoteException caso ocorra um erro RMI
   */
  void testInvokeAndWait(boolean useWorkAround) throws java.rmi.RemoteException;
}
